<!doctype html>
<html lang="en">
 <head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="generator" content="Asciidoctor 2.0.23">
  <meta name="author" content="Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation">
  <link rel="icon" type="image/png" href="../favicon.png">
  <title>Terminal descriptions | Eclipse ESCET™ development documentation</title>
  <link rel="stylesheet" href="../assets/asciidoctor-escet-dev.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <link rel="stylesheet" href="../assets/styles/asciidoctor-highlightjs-escet.min.css"><!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <meta name="robots" content="noindex">
  <script type="text/javascript" src="../assets/asciidoctor-escet-dev.js"></script>
 </head>
 <body class="book toc2 toc-left" onload="onLoad()">
  <div id="header">
   <div id="toc" class="toc2">
    <p class="website-link">Part of: <a href="../..">Eclipse ESCET™ website</a></p>
    <div id="toctitle">
     Eclipse ESCET™ development documentation
    </div>
    <ul class="sectlevel1">
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../index.html">Home</a></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../index.html#eclipse-escet-development">Eclipse ESCET development</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../development/dev-list.html">The Eclipse ESCET dev-list</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../development/development-process.html">Development process</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/development-process.html#issue-tracking">Issue tracking</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/development-process.html#releases-and-milestones">Releases and milestones</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/development-process.html#working-on-issues">Working on issues</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/development-process.html#working-with-branches">Working with branches</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/development-process.html#commits">Commits</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/development-process.html#merge-requests">Merge requests</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../development/development-process.html#collaborating-with-contributors-on-a-merge-request">Collaborating with contributors on a merge request</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../development/development-process.html#simple-approach">Simple approach</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../development/development-process.html#advanced-approach">Advanced approach</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../development/development-process.html#fork-collaboration-script-support">Fork collaboration script support</a></li>
          </ul></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../development/contributing.html">Contributing</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/contributing.html#how-to-contribute-to-eclipse-escet">How to contribute to Eclipse ESCET</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/contributing.html#keeping-in-sync-with-the-official-eclipse-escet-gitlab-repository">Keeping in sync with the official Eclipse ESCET GitLab repository</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/contributing.html#how-to-become-a-committer">How to become a committer</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../development/issue-tracking.html">Issue tracking</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../development/dev-env-setup.html">Development environment setup</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../development/git-repo.html">Git repositories</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/git-repo.html#repository-structure">Repository structure</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/git-repo.html#language-directories">Language directories</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/git-repo.html#middle-layer-common-functionality">Middle layer common functionality</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../development/coding-standards.html">Coding standards</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../development/building-and-testing.html">Building and testing</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../development/release-process.html">Release process</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/release-process.html#release-policy">Release policy</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/release-process.html#release-retention-policy">Release retention policy</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/release-process.html#planning-for-a-next-version">Planning for a next version</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/release-process.html#preparing-git-repository-for-a-next-version">Preparing Git repository for a next version</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/release-process.html#working-on-a-release">Working on a release</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/release-process.html#preparing-a-release">Preparing a release</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/release-process.html#preparing-a-progress-review">Preparing a progress review</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/release-process.html#performing-a-release">Performing a release</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/release-process.html#removing-archiving-old-releases">Removing/archiving old releases</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../development/third-party-tools.html">Third party tools</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../development/dependency-upgrades.html">Dependency upgrades</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/dependency-upgrades.html#eclipse-platform-ide-upgrades">Eclipse Platform/IDE upgrades</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/dependency-upgrades.html#tycho-upgrades">Tycho upgrades</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/dependency-upgrades.html#java-upgrades">Java upgrades</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../development/license-year-update.html">License year update</a></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../app-framework/index.html">Application framework</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../app-framework/introduction.html">Introduction</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../app-framework/standalone-vs-eclipse.html">Stand-alone execution versus Eclipse IDE</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#application-static-information">Application static information</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#application-options">Application options</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#stdin-stdout-and-stderr">Stdin, stdout, and stderr</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#graphical-user-interfaces-guis-and-swt">Graphical User Interfaces (GUIs) and SWT</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#application-termination">Application termination</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#sigint">SIGINT</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#exceptions">Exceptions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#system-properties">System properties</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#file-paths-and-current-working-directory">File paths and current working directory</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../app-framework/application-class.html">The Application class</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../app-framework/exception-framework.html">The exception framework</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/exception-framework.html#end-user-exceptions">End-user exceptions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/exception-framework.html#internal-exceptions">Internal exceptions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/exception-framework.html#chained-exceptions">Chained exceptions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/exception-framework.html#development-mode">Development mode</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../app-framework/exit-codes.html">Exit codes</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../app-framework/io-framework.html">The I/O framework</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/io-framework.html#output-components">Output components</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/io-framework.html#output-provider">Output provider</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/io-framework.html#stdout-and-stderr">Stdout and stderr</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/io-framework.html#stdin">Stdin</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/io-framework.html#buffering-and-flushing">Buffering and flushing</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../app-framework/option-framework.html">The option framework</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#the-option-class">The option class</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#command-line-options-and-the-option-dialog">Command line options and the option dialog</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#option-categories">Option categories</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#instantiating-options">Instantiating options</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#getting-and-setting-option-values">Getting and setting option values</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#option-processing-order">Option processing order</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#command-line-option-syntax">Command line option syntax</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#implementing-your-own-options">Implementing your own options</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#standard-options">Standard options</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../app-framework/compiler-framework.html">The compiler framework</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../app-framework/implement-your-application.html">How to implement your own application</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/implement-your-application.html#the-runinternal-method">The runInternal method</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../app-framework/registration.html">Application registration</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/registration.html#multi-threaded-applications">Multi-threaded applications</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/registration.html#unit-tests">Unit tests</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/registration.html#running-an-application-from-another-application">Running an application from another application</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../app-framework/execution.html">Execution</a></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../dsm/index.html">Design Structure Matrix (DSM) library</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../dsm/entrypoint.html">Code organization</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../dsm/algorithm.html">Algorithm and code</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../dsm/busdetection.html">Bus detection algorithms</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../dsm/references.html">References</a></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../multivalue/index.html">Multi-value Decision Diagrams library</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../multivalue/goals.html">Goals</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../multivalue/variables-and-relations.html">Variables and relations</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../multivalue/combining-relations.html">Combining relations</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../multivalue/computing.html">Computing</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../multivalue/practical-usage.html">Practical usage</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../multivalue/practical-usage.html#variables">Variables</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../multivalue/practical-usage.html#trees-and-relations">Trees and relations</a></li>
        </ul></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../rail/index.html">Rail diagram generator</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../rail/introduction.html">Introduction</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../rail/examples.html">Examples</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/examples.html#diagrams-and-sequences">Diagrams and sequences</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/examples.html#choices">Choices</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/examples.html#optional">Optional</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/examples.html#repetition">Repetition</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/examples.html#splitting-long-sequences">Splitting long sequences</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/examples.html#referencing-a-path-in-the-diagram">Referencing a path in the diagram</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/examples.html#terminals">Terminals</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/examples.html#meta-terminals">Meta-terminals</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/examples.html#further-reading">Further reading</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../rail/customizing-output.html">Customizing output</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#syntax-of-the-properties-file">Syntax of the properties file</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#kinds-of-values">Kinds of values</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#global-settings">Global settings</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#diagram-settings">Diagram settings</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#empty-node">Empty node</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#branch-label">Branch label</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../rail/customizing-output.html#name-node">Name node</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#terminal-text-and-box-properties">Terminal text and box properties</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#meta-terminal-text-and-box-properties">Meta-terminal text and box properties</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#non-terminal-text-and-box-properties">Non-terminal text and box properties</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#token-text-translations">Token text translations</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#sequence">Sequence</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#choice">Choice</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#repetition">Repetition</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../rail/customizing-output.html#debugging-properties">Debugging properties</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#hierarchy">Hierarchy</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#constraint-solving">Constraint solving</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#coordinates">Coordinates</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/customizing-output.html#default-property-values">Default property values</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../rail/commandline.html">Command-line arguments</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../rail/lexical-syntax.html">Lexical syntax</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/lexical-syntax.html#whitespace">Whitespace</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/lexical-syntax.html#comments">Comments</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/lexical-syntax.html#terminals">Terminals</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../rail/grammar.html">Grammar</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../rail/debugging.html">Debugging</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/debugging.html#global-internal-structure-of-the-generator">Global internal structure of the generator</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../rail/debugging.html#analyzing-output">Analyzing output</a></li>
        </ul></li>
      </ul></li>
     <li class="toc-cur-page-ancestor toc-item toc-item-parent expanded">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="index.html">SeText scanner/parser generator</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="lexical-syntax.html">SeText lexical syntax</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="specifying-lexical-syntax.html">Specifying lexical syntax using SeText</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="regular-expressions.html">Regular expressions</a></li>
       <li class="toc-cur-page toc-item expanded">
        <div class="toc-item-marker"></div><a href="#">Terminal descriptions</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="imports.html">Imports</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="scanner-hooks.html">Scanner hooks</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="specifying-grammars.html">Specifying grammars using SeText</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="parser-hooks.html">Parser hooks</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="usage-hints.html">Usage hints</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="generated-scanners-parsers.html">Generated scanners/parsers</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="using-in-an-eclipse-plugin-project.html">Using SeText in an Eclipse Plug-in Project</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="limitations.html">Limitations</a></li>
      </ul></li>
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../legal.html">Legal</a></li>
    </ul>
   </div>
  </div>
  <div id="content">
   <div id="breadcrumbs">
    <a class="breadcrumb" href="../index.html">Eclipse ESCET™ development documentation</a> &gt; <a class="breadcrumb" href="index.html">SeText scanner/parser generator</a> &gt; <span class="breadcrumb">Terminal descriptions</span>
   </div>
   <h2 id="terminal-descriptions"><a class="anchor" href="#"></a>Terminal descriptions</h2>
   <div class="paragraph">
    <p>Terminals can be given an end user readable description (just before the semicolon), for use in parser error messages:</p>
   </div>
   <div class="listingblock">
    <div class="content">
     <pre class="highlightjs highlight"><code class="language-setext hljs" data-lang="setext">@terminals:
  @keywords Operators = and            // "and"
                        or;            // "or"
  IDTK   = "[a-z]+" [an identifier];   // an identifier
  ID2TK  = "[A-Z]+" [ an identifier ]; // an identifier
  ASNGTK = ":=";                       // ":="
  @eof;                                // end-of-file
  X = "[abc]";                         // X
  "[def]";                             // no description</code></pre>
    </div>
   </div>
   <div class="paragraph">
    <p>Keyword literals (<code>ANDTK</code> and <code>ORTK</code> in the example above) have the keywords surrounded by double quotes as default description. Similarly, terminals defined by regular expressions without choice (no character classes, star operators, etc) and using only 'graphical' characters (no control characters, end-of-file, new lines, etc) also have the literal text that they match (surrounded by double quotes) as default description (see <code>ASGNTK</code> in the example above). The end-of-file token has <code>end-of-file</code> as default description. Keywords that don’t have a description and don’t have default descriptions as described above, get the name of the terminal as description (see <code>X</code> in the example above). If they don’t have a name, they have no description.</p>
   </div>
   <div class="paragraph">
    <p>Nameless terminals are not used by the parser, and therefore do not require a description. The end-of-file terminal has a default description, and can not be given a custom description. Giving a terminal a custom description if it already has a default description, leads to a warning.</p>
   </div>
  </div>
  <script src="../assets/highlight.min.js"></script>
  <script src="../assets/languages/asciidoc.min.js"></script>
  <script src="../assets/languages/bash.min.js"></script>
  <script src="../assets/languages/bnf.min.js"></script>
  <script src="../assets/languages/c.min.js"></script>
  <script src="../assets/languages/chi.min.js"></script>
  <script src="../assets/languages/cif.min.js"></script>
  <script src="../assets/languages/console.min.js"></script>
  <script src="../assets/languages/css.min.js"></script>
  <script src="../assets/languages/dsm.min.js"></script>
  <script src="../assets/languages/java.min.js"></script>
  <script src="../assets/languages/javascript.min.js"></script>
  <script src="../assets/languages/markdown.min.js"></script>
  <script src="../assets/languages/mcrl2.min.js"></script>
  <script src="../assets/languages/none.min.js"></script>
  <script src="../assets/languages/plcst.min.js"></script>
  <script src="../assets/languages/properties.min.js"></script>
  <script src="../assets/languages/raildiagram.min.js"></script>
  <script src="../assets/languages/setext.min.js"></script>
  <script src="../assets/languages/shell.min.js"></script>
  <script src="../assets/languages/tooldef.min.js"></script>
  <script src="../assets/languages/xml.min.js"></script>
  <script>
if (!hljs.initHighlighting.called) {
  hljs.initHighlighting.called = true
  ;[].slice.call(document.querySelectorAll('pre.highlight > code[data-lang]')).forEach(function (el) { hljs.highlightElement(el) })
}
</script>
  <script type="text/x-mathjax-config">
MathJax.Hub.Config({
  messageStyle: "none",
  tex2jax: {
    inlineMath: [["\\(", "\\)"]],
    displayMath: [["\\[", "\\]"]],
    ignoreClass: "nostem|nolatexmath"
  },
  asciimath2jax: {
    delimiters: [["\\$", "\\$"]],
    ignoreClass: "nostem|noasciimath"
  },
  TeX: { equationNumbers: { autoNumber: "none" } }
})
MathJax.Hub.Register.StartupHook("AsciiMath Jax Ready", function () {
  MathJax.InputJax.AsciiMath.postfilterHooks.Add(function (data, node) {
    if ((node = data.script.parentNode) && (node = node.parentNode) && node.classList.contains("stemblock")) {
      data.math.root.display = "block"
    }
    return data
  })
})
</script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.9/MathJax.js?config=TeX-MML-AM_HTMLorMML"></script><!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <div id="footer">
   <div id="footer-text">
    <span>Eclipse ESCET™ development documentation</span> | <span>Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation</span> | <span>version v6.0</span>
    <br><a href="https://www.eclipse.org">Eclipse Home</a> | <a href="https://www.eclipse.org/legal/privacy.php">Privacy Policy</a> | <a href="https://www.eclipse.org/legal/termsofuse.php">Terms of Use</a> | <a href="https://www.eclipse.org/legal/copyright.php">Copyright Agent</a> | <a href="https://www.eclipse.org/legal">Eclipse Legal</a>
   </div>
  </div>
 </body>
</html>